/**
* bbCode control by subBlue design [ www.subBlue.com ]
* Includes unixsafe colour palette selector by SHS`
*/

// Startup variables
var imageTag = false;
var theSelection = false;

// Check for Browser & Platform for PC & IE specific bits
// More details from: http://www.mozilla.org/docs/web-developer/sniffer/browser_type.html
var clientPC = navigator.userAgent.toLowerCase(); // Get client info
var clientVer = parseInt(navigator.appVersion); // Get browser version

var is_ie = ((clientPC.indexOf('msie') != -1) && (clientPC.indexOf('opera') == -1));
var is_win = ((clientPC.indexOf('win') != -1) || (clientPC.indexOf('16bit') != -1));

var baseHeight;
window.onload = initInsertions;

/**
* Shows the help messages in the helpline window
*/
function helpline(help)
{
	document.forms[form_name].helpbox.value = help_line[help];
}

/**
* Fix a bug involving the TextRange object. From
* http://www.frostjedi.com/terra/scripts/demo/caretBug.html
*/ 
function initInsertions() 
{
	var doc;

	if (document.forms[form_name])
	{
		doc = document;
	}
	else 
	{
		doc = opener.document;
	}

	var textarea = doc.forms[form_name].elements[text_name];
	if (is_ie && typeof(baseHeight) != 'number')
	{	
		textarea.focus();
		baseHeight = doc.selection.createRange().duplicate().boundingHeight;

		if (!document.forms[form_name])
		{
			document.body.focus();
		}
	}
}

/**
* bbstyle
*/
function bbstyle(bbnumber)
{	
	if (bbnumber != -1)
	{
		bbfontstyle(bbtags[bbnumber], bbtags[bbnumber+1]);
	} 
	else 
	{
		insert_text('[*]');
		document.forms[form_name].elements[text_name].focus();
	}
}

/**
* Apply bbcodes
*/
function bbfontstyle(bbopen, bbclose)
{
	theSelection = false;
		
	var textarea = document.forms[form_name].elements[text_name];

	textarea.focus();

	if ((clientVer >= 4) && is_ie && is_win)
	{
		// Get text selection
		theSelection = document.selection.createRange().text;

		if (theSelection)
		{
			// Add tags around selection
			document.selection.createRange().text = bbopen + theSelection + bbclose;
			document.forms[form_name].elements[text_name].focus();
			theSelection = '';
			return;
		}
	}
	else if (document.forms[form_name].elements[text_name].selectionEnd && (document.forms[form_name].elements[text_name].selectionEnd - document.forms[form_name].elements[text_name].selectionStart > 0))
	{
		mozWrap(document.forms[form_name].elements[text_name], bbopen, bbclose);
		document.forms[form_name].elements[text_name].focus();
		theSelection = '';
		return;
	}
	
	//The new position for the cursor after adding the bbcode
	var caret_pos = getCaretPosition(textarea).start;
	var new_pos = caret_pos + bbopen.length;

	// Open tag


// >>>BEGIN>>>SECTION>>>1

// >>>IMG_L>>>1
   if (bbopen == '[img_l]')
	{
	    var Error = '';
		var IMGL = prompt('Bild URL eingeben\r\nhttp://www.media.de/galerie/pic.jpg' , '');
		if (!IMGL) {
        Error = "Du hast keine Bild URL eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
		if (IMGL) {
			insert_text(bbopen + IMGL + bbclose);
		}
		else {
	insert_text(bbopen + bbclose);
		}
	}

// >>>IMG_R>>>1
   else if (bbopen == '[img_r]')
	{
	    var Error = '';
		var IMGR = prompt('Bild URL eingeben\r\nhttp://www.media.de/galerie/pic.jpg' , '');
		if (!IMGR) {
        Error = "Du hast keine Bild URL eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
		if (IMGR) {
			insert_text(bbopen + IMGR + bbclose);
		}
		else {
			insert_text(bbopen + bbclose);
		}
	}

// >>>FLV>>>1
   else if (bbopen == '[flv]')
	{
	    var Error = '';
		var FLV = prompt('FLV Link eingeben\r\nhttp://www.media.de/video/clip.flv' , '');
		if (!FLV) {
        Error = "Du hast keinen FLV Link eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
		if (FLV) {
			insert_text(bbopen + FLV + bbclose);
		}
		else {
			insert_text(bbopen + bbclose);
		}
	}

// >>>STREAM>>>1
   else if (bbopen == '[stream]')
	{
	    var Error = '';
		var STREAM = prompt('MP3 Link eingeben\r\nhttp://www.media.de/music/song.mp3' , '');
		if (!STREAM) {
        Error = "Du hast keinen MP3 Link eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
		if (STREAM) {
			insert_text(bbopen + STREAM + bbclose);
		}
		else {
			insert_text(bbopen + bbclose);
		}
	}

// >>>FLASH_I>>>1
   else if (bbopen == '[flash_i]')
	{
	    var Error = '';
		var FLASHI = prompt('Flash Link eingeben\r\nhttp://www.media.de/video/clip.swf' , '');
		if (!FLASHI) {
        Error = "Du hast keinen Flash Link eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
		if (FLASHI) {
			insert_text(bbopen + FLASHI + bbclose);
		}
		else {
			insert_text(bbopen + bbclose);
		}
	}

// >>>MOV>>>1
   else if (bbopen == '[mov]')
	{
	    var Error = '';
		var MOV = prompt('Quicktime Link eingeben\r\nhttp://www.media.de/video/clip.mov' , '');
		if (!MOV) {
        Error = "Du hast keinen Quicktime Link eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
		if (MOV) {
			insert_text(bbopen + MOV + bbclose);
		}
		else {
			insert_text(bbopen + bbclose);
		}
	}

// >>>RAM>>>1
   else if (bbopen == '[rm]')
	{
	    var Error = '';
		var RM = prompt('RealTime Link eingeben\r\nhttp://www.media.de/video/clip.rm(*.ram)' , '');
		if (!RM) {
        Error = "Du hast keinen RealTime Link eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
		if (RM) {
			insert_text(bbopen + RM + bbclose);
		}
		else {
			insert_text(bbopen + bbclose);
		}
	}

// >>>WMV>>>1
   else if (bbopen == '[wmv]')
	{
	    var Error = '';
		var WMV = prompt('Windows Media Link eingeben\r\nhttp://www.media.de/video/clip.wmv' , '');
		if (!WMV) {
        Error = "Du hast keinen Windows Media Link eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
		if (WMV) {
			insert_text(bbopen + WMV + bbclose);
		}
		else {
			insert_text(bbopen + bbclose);
		}
	}

// >>>DIVX>>>1
   else if (bbopen == '[divx]')
	{
	    var Error = '';
		var DIVX = prompt('DIVX Link eingeben\r\nhttp://www.media.de/video/clip.divx' , '');
		if (!DIVX) {
        Error = "Du hast keinen DIVX Link eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
		if (DIVX) {
			insert_text(bbopen + DIVX + bbclose);
		}
		else {
			insert_text(bbopen + bbclose);
		}
	}


// >>>MAIL>>>1
   else if (bbopen == '[mail=]')
	{
	    var Error = '';
		var TESTMAILNAME = prompt('E-Mail Namen eingeben\r\nNur das, was vor dem @ steht' , '');
		if (!TESTMAILNAME) {
        Error = "Du hast keinen E-Mail Namen eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
		var TESTMAILDOMAIN = prompt('Domain-Namen eingeben\r\nAlso alles, was nach dem @ und vor dem .xx steht' , '');
		if (!TESTMAILDOMAIN) {
        Error = "Du hast keinen Domain-Namen eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
		var TESTMAILTLD = prompt('Top-Level-Domain (TLD) eingeben\r\nOhne den Punkt davor: de, com, net etc.' , '');
		if (!TESTMAILTLD) {
        Error = "Du hast keinen Top-Level-Domain eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
        var TESTMAILDESCRIPT = prompt('Mailbezeichnung eingeben\r\nz.B.: Martins E-Mail Adresse\r\nAuf keinen Fall die E-Mail Adresse eingeben ;)' , '');
	    if (!TESTMAILDESCRIPT) {
        Error = "Du hast keine Mailbezeichnung eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
		if (TESTMAILNAME && TESTMAILDOMAIN && TESTMAILTLD && TESTMAILDESCRIPT) {
			insert_text('[mail=' + TESTMAILNAME + '|' + TESTMAILTLD + '|' + TESTMAILDOMAIN + ']' + TESTMAILDESCRIPT + bbclose);
		}
		else {
			insert_text(bbopen + bbclose);
		}
	}

// >>>URL>>>1
else if (bbopen == '[url]')
	{
	    var Error = '';
		var URL = prompt('URL eingeben' , '');
		if (!URL) {
        Error = "Du hast keine URL eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
		var URLTITEL = prompt('Beschreibung oder Titel eingeben' , '');
		if (!URLTITEL) {
        Error = "Du hast keine Beschreibung oder Titel eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
		if (URL && URLTITEL) {
			insert_text('[url=' + URL + ']' + URLTITEL + bbclose);
		}
		else {
			insert_text(bbopen + bbclose);
		}
	}

// >>>QUOTE>>>1
else if (bbopen == '[quote]')
	{
	    var Error = '';
		var QUOTENAME = prompt('Namen des Zitierten eingeben' , '');
		if (!QUOTENAME) {
        Error = "Du hast keinen Namen eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
		if (QUOTENAME) {
			insert_text('[quote=' + '"' + QUOTENAME + '"' + ']' + bbclose);
		}
		else {
			insert_text(bbopen + bbclose);
		}
	}

// >>>YOUTUBE>>>1
   else if (bbopen == '[youtube]')
	{
	    var Error = '';
		var YOUTUBE = prompt('Youtube Link eingeben\r\nhttp://de.youtube.com/watch?v=xxxxxxxxxxx' , '');
		if (!YOUTUBE) {
        Error = "Du hast keinen Youtube Link eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
		if (YOUTUBE) {
			insert_text(bbopen + YOUTUBE + bbclose);
		}
		else {
			insert_text(bbopen + bbclose);
		}
	}

// >>>GVIDEO>>>1
   else if (bbopen == '[gvideo]')
	{
	    var Error = '';
		var GVIDEO = prompt('GoogleVideo Link eingeben\r\nhttp://video.google.de/videoplay?docid=123456789' , '');
		if (!GVIDEO) {
        Error = "Du hast keinen GoogleVideo Link eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
		if (GVIDEO) {
			insert_text(bbopen + GVIDEO + bbclose);
		}
		else {
			insert_text(bbopen + bbclose);
		}
	}

// >>>MYSPACE>>>1
   else if (bbopen == '[myspace]')
	{
	    var Error = '';
		var MYSPACE = prompt('Myspace Link eingeben\r\nhttp://vids.myspace.com/index.cfm?fuseaction=vids.individual&videoid=12345' , '');
		if (!MYSPACE) {
        Error = "Du hast keinen Myspace Link eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
		if (MYSPACE) {
			insert_text(bbopen + MYSPACE + bbclose);
		}
		else {
			insert_text(bbopen + bbclose);
		}
	}

// >>>MYVIDEO>>>1
   else if (bbopen == '[myvideo]')
	{
	    var Error = '';
		var MYVIDEO = prompt('Myvideo Link eingeben\r\nhttp://www.myvideo.de/watch/1234567' , '');
		if (!MYVIDEO) {
        Error = "Du hast keinen Myvideo Link eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
		if (MYVIDEO) {
			insert_text(bbopen + MYVIDEO + bbclose);
		}
		else {
			insert_text(bbopen + bbclose);
		}
	}

// >>>CLIPFISH>>>1
   else if (bbopen == '[clipfish]')
	{
	    var Error = '';
		var CLIPFISH = prompt('Clipfish Link eingeben\r\nhttp://www.clipfish.de/player.php?videoid=xxxxxxxxxxxx' , '');
		if (!CLIPFISH) {
        Error = "Du hast keinen Clipfish Link eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
		if (CLIPFISH) {
			insert_text(bbopen + CLIPFISH + bbclose);
		}
		else {
			insert_text(bbopen + bbclose);
		}
	}

// >>>AMAZON>>>1
   else if (bbopen == '[amazon]')
	{
	    var Error = '';
		var AMAZON = prompt('ISBN-Nummer eingeben\r\nz.B.: 3897214210' , '');
		if (!AMAZON) {
        Error = "Du hast keine ISBN-Nummer eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
		if (AMAZON) {
			insert_text(bbopen + AMAZON + bbclose);
		}
		else {
			insert_text(bbopen + bbclose);
		}
	}

// >>>WIKI>>>1

    else if (bbopen == '[wiki=]')
	{
		var Error = '';
		var WIKIWORD = prompt('Wiki Begriff eingeben' , '');
		if (!WIKIWORD) {
        Error = "Du hast keinen Wiki Begriff eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
		if (WIKIWORD && WIKIWORD != '') {
		var WIKITITLE = prompt('Wiki Titel eingeben' , '');
	    if (!WIKITITLE) {
        Error = "Du hast keinen Wiki Titel eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
			if (WIKITITLE) {
				insert_text("[wiki=" + WIKIWORD + "]" + WIKITITLE + bbclose);
			}
		}
	}


// >>>GMAP2>>>1

    else if (bbopen == '[gmap2]')
	{
		var Error = '';
		var LOCATION2 = prompt('Location eingeben\r\nz.B.: Berlin, Unter den Linden' , '');
		if (!LOCATION2) {
        Error = "Du hast keine Location eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
			if (LOCATION2) {
				insert_text("[gmap2]" + LOCATION2 + bbclose);
			}
	}

// >>>GMAP>>>1	
else if (bbopen == '[gmap=]')
	{
		var Error = '';
		var LOCATION = prompt('Location oder Beschreibung eingeben\r\n' , '');
		if (!LOCATION) {
        Error = "Du hast keine Location eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
		var UTF8LINK = prompt('Google Map UTF8 Link eingeben\r\nAlso nur den Teil von UTF8 bis z=xx:\r\nUTF8&ll=50.796535,7.206337&spn=0.000815,0.001824&z=19' , '');
	    if (!UTF8LINK) {
        Error = "Du hast keinen UTF8 Link eingeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
		if (LOCATION && UTF8LINK) {
			insert_text("[gmap=" + LOCATION + "]" + "http://maps.google.de/maps?t=k&ie=" + UTF8LINK  + bbclose);
		}
		else {
			insert_text(bbopen + bbclose);
		}
	}


// >>>IMG>>>1
   else if (bbopen == '[img]')
	{
	    var Error = '';
		var IMG = prompt('Bild URL eingeben\r\nhttp://www.media.de/galerie/pic.jpg' , '');
		if (!IMG) {
        Error = "Du hast keine Bild URL eingegeben";
		}
		if (Error) {
        alert("Fehler: "+Error);
        return;
        }
		if (IMG) {
			insert_text(bbopen + IMG + bbclose);
		}
		else {
			insert_text(bbopen + bbclose);
		}
	}

// >>>ALL_OTHER_ONE_CLICK_TAGS>>>
	else {
	insert_text(bbopen + bbclose);
	}
// >>>END>>>SECTION>>>1


	// Center the cursor when we don't have a selection
	// Gecko and proper browsers
	if (!isNaN(textarea.selectionStart))
	{
		textarea.selectionStart = new_pos;
		textarea.selectionEnd = new_pos;
	}	
	// IE
	else if (document.selection)
	{
		var range = textarea.createTextRange(); 
		range.move("character", new_pos); 
		range.select();
		storeCaret(textarea);
	}

	textarea.focus();
	return;
}

/**
* Insert text at position
*/
function insert_text(text, spaces, popup)
{
	var textarea;
	
	if (!popup) 
	{
		textarea = document.forms[form_name].elements[text_name];
	} 
	else 
	{
		textarea = opener.document.forms[form_name].elements[text_name];
	}
	if (spaces) 
	{
		text = ' ' + text + ' ';
	}
	
	if (!isNaN(textarea.selectionStart))
	{
		var sel_start = textarea.selectionStart;
		var sel_end = textarea.selectionEnd;

		mozWrap(textarea, text, '')
		textarea.selectionStart = sel_start + text.length;
		textarea.selectionEnd = sel_end + text.length;
	}	
	
	else if (textarea.createTextRange && textarea.caretPos)
	{
		if (baseHeight != textarea.caretPos.boundingHeight) 
		{
			textarea.focus();
			storeCaret(textarea);
		}		
		var caret_pos = textarea.caretPos;
		caret_pos.text = caret_pos.text.charAt(caret_pos.text.length - 1) == ' ' ? caret_pos.text + text + ' ' : caret_pos.text + text;
		
	}
	else
	{
		textarea.value = textarea.value + text;
	}
	if (!popup) 
	{
		textarea.focus();
	} 	

}

/**
* Add inline attachment at position
*/
function attach_inline(index, filename)
{
	insert_text('[attachment=' + index + ']' + filename + '[/attachment]');
	document.forms[form_name].elements[text_name].focus();
}

/**
* Add quote text to message
*/
function addquote(post_id, username)
{
	var message_name = 'message_' + post_id;
	var theSelection = '';
	var divarea = false;

	if (document.all)
	{
		divarea = document.all[message_name];
	}
	else
	{
		divarea = document.getElementById(message_name);
	}

	// Get text selection - not only the post content :(
	if (window.getSelection)
	{
		theSelection = window.getSelection().toString();
	}
	else if (document.getSelection)
	{
		theSelection = document.getSelection();
	}
	else if (document.selection)
	{
		theSelection = document.selection.createRange().text;
	}

	if (theSelection == '' || typeof theSelection == 'undefined' || theSelection == null)
	{
		if (divarea.innerHTML)
		{
			theSelection = divarea.innerHTML.replace(/<br>/ig, '\n');
			theSelection = theSelection.replace(/<br\/>/ig, '\n');
			theSelection = theSelection.replace(/&lt\;/ig, '<');
			theSelection = theSelection.replace(/&gt\;/ig, '>');
			theSelection = theSelection.replace(/&amp\;/ig, '&');
		}
		else if (document.all)
		{
			theSelection = divarea.innerText;
		}
		else if (divarea.textContent)
		{
			theSelection = divarea.textContent;
		}
		else if (divarea.firstChild.nodeValue)
		{
			theSelection = divarea.firstChild.nodeValue;
		}
	}

	if (theSelection)
	{
		insert_text('[quote="' + username + '"]' + theSelection + '[/quote]');
	}

	return;
}

/**
* From http://www.massless.org/mozedit/
*/
function mozWrap(txtarea, open, close)
{
	var selLength = txtarea.textLength;
	var selStart = txtarea.selectionStart;
	var selEnd = txtarea.selectionEnd;
	var scrollTop = txtarea.scrollTop;

	if (selEnd == 1 || selEnd == 2) 
	{
		selEnd = selLength;
	}

	var s1 = (txtarea.value).substring(0,selStart);
	var s2 = (txtarea.value).substring(selStart, selEnd)
	var s3 = (txtarea.value).substring(selEnd, selLength);

	txtarea.value = s1 + open + s2 + close + s3;
	// with special thanks to Ash Hi Fi Zone
	txtarea.selectionStart = selStart + open.length;
    txtarea.selectionEnd = selEnd + open.length;
	// txtarea.selectionStart = selEnd + open.length + close.length;
	// txtarea.selectionEnd = txtarea.selectionStart;
	txtarea.focus();
	txtarea.scrollTop = scrollTop;

	return;
}

/**
* Insert at Caret position. Code from
* http://www.faqts.com/knowledge_base/view.phtml/aid/1052/fid/130
*/
function storeCaret(textEl)
{
	if (textEl.createTextRange)
	{
		textEl.caretPos = document.selection.createRange().duplicate();
	}
}

/**
* Color pallette
*/
function colorPalette(dir, width, height)
{
	var r = 0, g = 0, b = 0;
	var numberList = new Array(6);
	var color = '';

	numberList[0] = '00';
	numberList[1] = '40';
	numberList[2] = '80';
	numberList[3] = 'BF';
	numberList[4] = 'FF';

	document.writeln('<table cellspacing="1" cellpadding="0" border="0">');

	for (r = 0; r < 5; r++)
	{
		if (dir == 'h')
		{
			document.writeln('<tr>');
		}

		for (g = 0; g < 5; g++)
		{
			if (dir == 'v')
			{
				document.writeln('<tr>');
			}
			
			for (b = 0; b < 5; b++)
			{
				color = String(numberList[r]) + String(numberList[g]) + String(numberList[b]);
				document.write('<td bgcolor="#' + color + '">');
				document.write('<a href="#" onclick="bbfontstyle(\'[color=#' + color + ']\', \'[/color]\'); return false;" onmouseover="helpline(\'s\');"  onmouseout="helpline(\'tip\');"><img src="images/spacer.gif" width="' + width + '" height="' + height + '" alt="#' + color + '" title="#' + color + '" /></a>');
				document.writeln('</td>');
			}

			if (dir == 'v')
			{
				document.writeln('</tr>');
			}
		}

		if (dir == 'h')
		{
			document.writeln('</tr>');
		}
	}
	document.writeln('</table>');
}


/**
* Caret Position object
*/
function caretPosition()
{
	var start = null;
	var end = null;
}


/**
* Get the caret position in an textarea
*/
function getCaretPosition(txtarea)
{
	var caretPos = new caretPosition();
	
	// simple Gecko/Opera way
	if(txtarea.selectionStart || txtarea.selectionStart == 0)
	{
		caretPos.start = txtarea.selectionStart;
		caretPos.end = txtarea.selectionEnd;
	}
	// dirty and slow IE way
	else if(document.selection)
	{
		// get current selection
		var range = document.selection.createRange();

		// a new selection of the whole textarea
		var range_all = document.body.createTextRange();
		range_all.moveToElementText(txtarea);
		
		// calculate selection start point by moving beginning of range_all to beginning of range
		var sel_start;
		for (sel_start = 0; range_all.compareEndPoints('StartToStart', range) < 0; sel_start++)
		{		
			range_all.moveStart('character', 1);
		}
	
		txtarea.sel_start = sel_start;
	
		// we ignore the end value for IE, this is already dirty enough and we don't need it
		caretPos.start = txtarea.sel_start;
		caretPos.end = txtarea.sel_start;
	}

	return caretPos;
}